;
;       *************************************************
;       *                                               *
;       *                  << MUSIC >>                  *
;       *                                               *
;       *                       by                      *
;       *                                               *
;       *  STEVEN HOLLYWOD      &       IAN S WILLIAMS  *
;       *                                               *
;       *************************************************
;
;
mt_ipcom        equ     17
;
;
start
        lea     prelude,a0      ; Load the tune data location into a0
        moveq   #100,d2         ; Play it very fast
        bsr.s   hi_fi           ; Branch to hi_fi
        rts
;
;
;
hi_fi
nexnoi  lea     messsound,a3    ; Loads the pointer to messsound
        move.b  (a0)+,d7        ; Reads the pitch parameter into d7
        move.b  d7,6(a3)        ; Stores the pitch in the sound table
        bne.s   not_qu          ; Is pitch 0?
        bsr.s   shush           ; Yes: kill last sound
        bra.s   count           ; Pause for specified length
not_qu  cmp.b   #255,d7         ; Is pitch 255?
        beq.s   shush           ; Yes: Return from hi_fi
        moveq   #mt_ipcom,d0    ; Make sound
        trap    #1              ;
count   moveq   #0,d1           ; Clear d1 (long)
        move.b  (a0)+,d7        ; Load note length into d7
        move.b  d7,d1           ; Transfer to d1 (d7 is needed later)
        mulu    d2,d1           ; Multiply by 40 (steps up length)
mupause moveq   #20,d6          ; Fixed pause
npause  dbf     d6,npause       ;
        dbf     d1,mupause      ; Counts down for pause length
        tst.b   d7              ; Test length
        bpl.s   nexnoi          ; If length positive get next note
        bsr.s   shush           ; If bit 7 is set then stop sound
        bra.s   nexnoi          ; Play next note (start again)
shush   lea     quiet_note,a3   ; These three lines
        moveq   #mt_ipcom,d0    ; Stop the note
        trap    #1
        rts
;
;  Music data is inserted here and preceded by the label
;
prelude
        dc.b    38,16,22,16,9,16,22,16
        dc.b    41,16,22,16,11,16,22,16
        dc.b    38,16,22,16,9,16,22,16
        dc.b    55,16,15,16,6,16,15,16
        dc.b    46,16,28,16,14,16,28,16
        dc.b    55,16,28,16,15,16,28,16
        dc.b    46,16,28,16,14,16,28,16
        dc.b    66,16,22,16,9,16,22,16
;       :
        dc.b    62,16,38,16,18,16,38,16
        dc.b    66,16,38,16,22,16,38,16
        dc.b    62,16,38,16,18,16,38,16
        dc.b    87,16,28,16,14,16,28,16
        dc.b    76,16,28,16,26,16,28,16
        dc.b    87,16,28,16,18,16,28,16
        dc.b    92,16,33,16,22,16,33,16
        dc.b    120,16,41,16,26,16,41,16
;       :
        dc.b    87,16,9,16,6,16,9,16
        dc.b    55,16,14,16,9,16,14,16
        dc.b    66,16,22,16,14,16,22,16
        dc.b    87,16,28,16,22,16,28,16
        dc.b    102,16,66,16,58,16,50,16
        dc.b    46,16,41,16,38,16,33,16
        dc.b    38,16,46,16,41,16,38,16
        dc.b    33,16,28,16,24,16,22,16
;       :
        dc.b    33,16,24,16,18,16,24,16
        dc.b    46,16,33,16,24,16,33,16
        dc.b    58,16,46,16,33,16,46,16
        dc.b    76,16,58,16,46,16,76,16
        dc.b    76,16,58,16,46,16,76,16
        dc.b    102,16,11,16,7,16,11,16
        dc.b    127,16,18,16,11,16,18,16
        dc.b    162,32,24,16,18,16,24,16
;       :
        dc.b    92,16,58,16,55,16,46,16
        dc.b    41,16,36,16,33,16,28,16
        dc.b    33,16,41,16,36,16,33,16
        dc.b    28,16,24,16,22,16,28,16
        dc.b    33,127,0,32,162,127
        dc.b    -1              ; -1 is the end of tune marker
        ds.w    0               ; align
messsound
        dc.b    $0a,8           ; Command byte, no. of parameters
        dc.l    $0000aaaa       ; Instructs trap to send information
                                ; to IPC in bytes (see text)
        dc.b    0,0             ; Pitch 1, pitch 2 set to 0
        dc.b    0,0,255,255     ; Grad_x (0,0), Duration (65535)
        dc.b    0,0             ; No Grad_x, wrap, fuzziness or Rnd
        dc.b    1               ; No return parameters - see text!!!!
        ds.w    0               ; align
quiet_note
        dc.b    $0b,0           ; Command byte, no. of parameters
        dc.l    $0              ; Send no data
        dc.b    1               ; As above...
;
        end
